//
//  RootViewController.m
//  TableView
//
//  Created by iPhone SDK Articles on 1/17/09.
//  Copyright www.iPhoneSDKArticles.com 2009. 
//

#import "RootViewController.h"
#import "TableViewAppDelegate.h"
#import "DetailViewController.h"
#import "OverlayViewController.h"
#import "LoginViewController.h"
#import "HTMLParser.h"

@implementation RootViewController

- (void)viewDidLoad {
    [super viewDidLoad];
	
	self.navigationController.navigationBar.tintColor= [UIColor blackColor];

	//color = [searchBar valueForKey:@"_color"];
	//color.textColor = [UIColor blackColor];
	//searchBar.tintColor = [UIColor brownColor];
	
	//Values
	NSError *error = nil;
	HTMLParser *htmlBody;
	HTMLNode *node;
	NSArray *books;
	
	NSString *cadena;
	NSString *cadena2;
	NSString *cadena3;
	
		//Store the list of books
	listOfItems = [[NSMutableArray alloc]init];
	
		//Store the list of URLs of the books
	listOfURL = [[NSMutableArray alloc]init];
	
		//Store synopsis
	listOfDetails = [[NSMutableArray alloc]init];

		//Copy titles search
	copyListOfItems = [[NSMutableArray alloc] init];

	
	
	//HTML connection	
	htmlBody = [[HTMLParser alloc]initWithContentsOfURL:[NSURL URLWithString:@"http://proyecto.lavidapirata.es/bookshelf/"] error:&error];
		
	if(error)
	{
		NSLog(@"Error:@",error);
		return;
	}
	
	node = [htmlBody body];
	
	
	//Extract the name of the books
	printf("\n\n\n\n");
	
	//Find tags li in HTML code
	books = [node findChildTags: @"li"];
	
	cadena = [[NSString alloc]init];
	cadena2 = [[NSString alloc]init];
	cadena3 = [[NSString alloc]init];

	
	for(HTMLNode *resultado in books)
	{		
		cadena = [resultado getAttributeNamed:@"title"];
		cadena2 = [resultado getAttributeNamed:@"link"];
		cadena3 = [resultado getAttributeNamed:@"synopsis"];


		if(cadena)
		   {
			NSLog(@"Hemos cogido este libro:%@", cadena);
			[listOfItems addObject:cadena];
			
		   }
		if(cadena2)
		{
			
			NSLog(@"Hemos cogido esta URL:%@", cadena2);
			[listOfURL addObject:cadena2];
		}
		if(cadena3)
		{
			
			NSLog(@"Hemos cogido esta Detalles:%@", cadena3);
			[listOfDetails addObject:cadena3];
		}
	}
	
	
	
	[htmlBody release];
	
	
	//Set the title
	self.navigationItem.title = @"Books";
	
	//Add the search bar
	self.tableView.tableHeaderView = searchBar;
	searchBar.autocorrectionType = UITextAutocorrectionTypeNo;
	
	//Background searchBar
	UIImageView *iView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"background_brown.jpg"]];
	iView.frame = CGRectMake(0, 0, 320, 44);
	[searchBar insertSubview:iView atIndex:1];
	[iView release];
	
	searching = NO;
	letUserSelectRow = YES;
}


/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
		
		//number of sections
		return 1;
	
}

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	
	if (searching)
		return [copyListOfItems count];
	else {
		
		printf("ListaCountRow:%d\n", [listOfItems count]);

		return [listOfItems count];
		
	}
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
	
	
	//Nombre cuando buscas y cuando no buscas
	if(searching)
		return @"Search Results";
	
	else{
		return @"Books";
	}
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Set up the cell...
	
	if(searching) 
		cell.textLabel.text = [copyListOfItems objectAtIndex:indexPath.row];
	else {
		
		
		NSString *cellValue = [listOfItems objectAtIndex:indexPath.row];
		
		cell.textLabel.text = cellValue;
		
	}

    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	
	//Get the selecte book	
	NSString *selectedBook = nil;
	NSString *urlBook = nil;
	NSString *synopsis = nil;
	
	[self viewDidLoad];

	if(searching)
	{
		selectedBook = [copyListOfItems objectAtIndex:indexPath.row];
		
	}
	else {
	
		//Modificación para mostrar URL DEL LIBRO.
		
		selectedBook = [listOfItems objectAtIndex:indexPath.row];
	
		}
	
	if([listOfURL count] > 0)
	{
		urlBook = [listOfURL objectAtIndex:indexPath.row];

	}
	
	synopsis = [listOfDetails objectAtIndex:indexPath.row];

	
	//Initialize the detail view controller and display it.
	DetailViewController *dvController = [[DetailViewController alloc] initWithNibName:@"DetailView" bundle:[NSBundle mainBundle]];
	dvController.selectedBook = selectedBook;
	dvController.urlBook = urlBook;
	dvController.synopsis = synopsis;
	[self.navigationController pushViewController:dvController animated:YES];
	[dvController release];
	dvController = nil;
}

- (NSIndexPath *)tableView :(UITableView *)theTableView willSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	
	if(letUserSelectRow)
		return indexPath;
	else
		return nil;
}

- (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath {
	
	return UITableViewCellAccessoryDetailDisclosureButton;
	//return UITableViewCellAccessoryDisclosureIndicator;
}

- (void)tableView:(UITableView *)tableView accessoryButtonTappedForRowWithIndexPath:(NSIndexPath *)indexPath {
	
	//Lo usamso para que coja la llamada del botón de cada celda.
	[self tableView:tableView didSelectRowAtIndexPath:indexPath];
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark -
#pragma mark Search Bar 

- (void) searchBarTextDidBeginEditing:(UISearchBar *)theSearchBar {
	
	

	//This method is called again when the user clicks back from teh detail view.
	//So the overlay is displayed on the results, which is something we do not want to happen.
	if(searching)
		return;
	
	//Add the overlay view.
	if(ovController == nil)
		ovController = [[OverlayViewController alloc] initWithNibName:@"OverlayView" bundle:[NSBundle mainBundle]];
	
	CGFloat yaxis = self.navigationController.navigationBar.frame.size.height;
	CGFloat width = self.view.frame.size.width;
	CGFloat height = self.view.frame.size.height;
	
	//Parameters x = origion on x-axis, y = origon on y-axis.
	CGRect frame = CGRectMake(0, yaxis, width, height);
	ovController.view.frame = frame;	
	ovController.view.backgroundColor = [UIColor grayColor];
	ovController.view.alpha = 0.5;
	
	ovController.rvController = self;
	
	[self.tableView insertSubview:ovController.view aboveSubview:self.parentViewController.view];
	
	searching = YES;
	letUserSelectRow = NO;
	self.tableView.scrollEnabled = NO;
	
	//Add the done button.
	self.navigationItem.rightBarButtonItem = [[[UIBarButtonItem alloc] 
											   initWithBarButtonSystemItem:UIBarButtonSystemItemDone 
											   target:self action:@selector(doneSearching_Clicked:)] autorelease];
}

- (void)searchBar:(UISearchBar *)theSearchBar textDidChange:(NSString *)searchText {

	
	printf("Hemos llegado a SearchBarSearchButtonClicked1");

	//Remove all objects first.
	[copyListOfItems removeAllObjects];
	
	if([searchText length] > 0) {
		
		[ovController.view removeFromSuperview];
		searching = YES;
		letUserSelectRow = YES;
		self.tableView.scrollEnabled = YES;
		[self searchTableView];
	}
	else {
		
		[self.tableView insertSubview:ovController.view aboveSubview:self.parentViewController.view];
		
		searching = NO;
		letUserSelectRow = NO;
		self.tableView.scrollEnabled = NO;
	}
	
	[self.tableView reloadData];
}

- (void) searchBarSearchButtonClicked:(UISearchBar *)theSearchBar {
	
	[self searchTableView];
}

- (void) searchTableView {
	
	

	NSString *searchText = searchBar.text;
	for(NSString *sTemp in listOfItems)
	{
		//Comparamos sTemp con el texto buscado.
		NSRange titleResultRange = [sTemp rangeOfString:searchText options:NSCaseInsensitiveSearch];
	
		if(titleResultRange.length > 0)
		{
			[copyListOfItems addObject:sTemp];
		}
	}
	
}

- (void) doneSearching_Clicked:(id)sender {
	
	searchBar.text = @"";
	[searchBar resignFirstResponder];
	
	letUserSelectRow = YES;
	searching = NO;
	self.navigationItem.rightBarButtonItem = nil;
	self.tableView.scrollEnabled = YES;
	
	[ovController.view removeFromSuperview];
	[ovController release];
	ovController = nil;
	
	[self.tableView reloadData];
}

- (void)dealloc {
	
	[ovController release];
	[copyListOfItems release];
	[searchBar release];
	[listOfItems release];
    [super dealloc];
}


@end

